=== lib/Makefile ===
# Makefile for uClibc
#
# Copyright (C) 2000-2003 Erik Andersen <andersen@uclibc.org>
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU Library General Public
# License as published by the Free Software Foundation; either
# version 2 of the License, or (at your option) any later
# version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU Library General Public License for more details.
#
# You should have received a copy of the GNU Library General
# Public License along with this program; if not, write to the
# Free Software Foundation, Inc., 59 Temple Place, Suite 330,
# Boston, MA 02111-1307 USA


#--------------------------------------------------------------
# You shouldn't need to mess with anything beyond this point...
#--------------------------------------------------------------
noconfig_targets := menuconfig config oldconfig randconfig \
	defconfig allyesconfig allnoconfig clean distclean \
	release tags TAGS
TOPDIR=./
include Rules.mak
-include $(CONFIG_CONFIG)

DIRS=
ifeq ($(CONFIG_UCLIBC_0_9_28),y) 
DIRS += ldso libc
ifeq ($(strip $(UCLIBC_HAS_GETTEXT_AWARENESS)),y)
    DIRS += libintl
endif
ifeq ($(CONFIG_LIB_CRYPT_FORCE),y)
    DIRS += libcrypt
endif
ifeq ($(CONFIG_LIB_RESOLV_FORCE),y)
    DIRS += libresolv
endif
ifeq ($(CONFIG_LIB_NSL_FORCE),y)
    DIRS += libnsl
endif
ifeq ($(CONFIG_LIB_UTIL_FORCE),y)
    DIRS += libutil
endif
ifeq ($(CONFIG_LIB_RT_FORCE),y)
    DIRS += librt
endif
ifeq ($(CONFIG_LIB_LIBM_FORCE),y)
    DIRS += libm
endif
ifeq ($(CONFIG_LIB_LIBPTHREAD_FORCE),y)
    DIRS += libpthread
endif
endif

ifeq ($(CONFIG_LIB_LIBGMP_FORCE),y)
    DIRS += libgmp
endif
ifeq ($(CONFIG_LIB_ZLIB_FORCE),y)
    DIRS += zlib-1.2.3
endif
ifeq ($(CONFIG_LIB_LIBNVRAM_FORCE),y)
    DIRS += libnvram
endif
ifeq ($(CONFIG_LIB_LIBNTFS3G_FORCE),y)
    DIRS += libntfs-3g
endif
ifeq ($(CONFIG_LIB_LIBBT_FORCE),y)
    DIRS += libbluetooth
endif
ifeq ($(CONFIG_LIB_READLINE_FORCE),y)
    DIRS += libreadline
endif
ifeq ($(CONFIG_LIB_LIBSQLITE3_FORCE),y)
    DIRS += libsqlite3
endif
ifeq ($(CONFIG_LIB_LIBEXIF_FORCE),y)
    DIRS += libexif
endif
ifeq ($(CONFIG_LIB_LIBOGG_FORCE),y)
    DIRS += libogg
endif
ifeq ($(CONFIG_LIB_LIBVORBIS_FORCE),y)
    DIRS += libvorbis
endif
ifeq ($(CONFIG_LIB_LIBFLAC_FORCE),y)
    DIRS += libflac
endif
ifeq ($(CONFIG_LIB_LIBJPEG_FORCE),y)
    DIRS += libjpeg
endif
ifeq ($(CONFIG_LIB_LIBPCAP_FORCE),y)
    DIRS += libpcap-1.0.0
endif
ifeq ($(CONFIG_LIB_LIBEVENT_FORCE),y)
     DIRS += libevent-2.0.2-alpha
endif
ifeq ($(CONFIG_LIB_NCURSE_FORCE),y)
    DIRS += libncurses-5.7
endif
ifeq ($(CONFIG_LIB_FLEX_FORCE),y)
    DIRS += libflex
endif
ifeq ($(CONFIG_LIB_LIBUPNP_FORCE),y)
    DIRS += libupnp
endif
ifeq ($(CONFIG_LIB_LIBUPNP166_FORCE),y)
    DIRS += libupnp-1.6.6
endif
ifeq ($(CONFIG_LIB_LIBUPNP166_DMS_FORCE),y)
    DIRS += libupnp-1.6.6-dms
endif
ifeq ($(CONFIG_LIB_LIBFFMPEG_FORCE),y)
    DIRS += libffmpeg-0.5
endif
ifeq ($(CONFIG_LIB_LIBDLNA_FORCE),y)
    DIRS += libdlna-0.2.3
endif
ifeq ($(CONFIG_LIB_LIBGDBM_FORCE),y)
    DIRS += libgdbm-1.8.3
endif
ifeq ($(CONFIG_LIB_LIBID3TAG_FORCE),y)
    DIRS += libid3tag-0.15.1b
endif
ifeq ($(CONFIG_LIB_LIBZEBRA_FORCE),y)
    DIRS += libzebra
endif
ifeq ($(CONFIG_LIB_USB0112_FORCE),y)
    DIRS += libusb-0.1.12
endif
ifeq ($(CONFIG_LIB_USB100_FORCE),y)
    DIRS += libusb-1.0.0
endif
ifeq ($(CONFIG_LIB_PCRE_FORCE),y)
    DIRS += pcre-8.01
endif
ifeq ($(CONFIG_LIB_VSTR_FORCE),y)
    DIRS += vstr-1.0.15
endif

# mtd-utils-1.5.0

ifeq ($(CONFIG_LIB_LZO_FORCE),y)
    DIRS += lzo-2.03
endif
ifeq ($(CONFIG_LIB_E2FSPROGS_FORCE),y)
    DIRS += e2fsprogs-1.41.3
endif
# end


ifeq ($(strip $(HAVE_DOT_CONFIG)),y)

all: headers pregen subdirs shared finished

# In this section, we need .config
-include .config.cmd

shared: subdirs
ifeq ($(strip $(HAVE_SHARED)),y)
	$(SECHO)
	$(SECHO) Building shared libraries ...
	$(SECHO)
ifeq ($(CONFIG_UCLIBC_0_9_28),y) 
	@$(MAKE) -C libc shared
	@$(MAKE) -C ldso shared

ifeq ($(CONFIG_LIB_CRYPT_FORCE),y)
	@$(MAKE) -C libcrypt shared
endif
ifeq ($(CONFIG_LIB_RESOLV_FORCE),y)
	@$(MAKE) -C libresolv shared
endif
ifeq ($(CONFIG_LIB_NSL_FORCE),y)
	@$(MAKE) -C libnsl shared
endif
ifeq ($(CONFIG_LIB_UTIL_FORCE),y)
	@$(MAKE) -C libutil shared
endif
ifeq ($(CONFIG_LIB_RT_FORCE),y)
	@$(MAKE) -C librt shared
endif
ifeq ($(CONFIG_LIB_LIBM_FORCE),y)
	@$(MAKE) -C libm shared
endif
ifeq ($(CONFIG_LIB_LIBPTHREAD_FORCE),y)
	@$(MAKE) -C libpthread shared
endif
ifeq ($(strip $(UCLIBC_HAS_GETTEXT_AWARENESS)),y)
	@$(MAKE) -C libintl shared
endif
endif

ifeq ($(CONFIG_LIB_LIBNVRAM_FORCE),y)
	@$(MAKE) -C libnvram shared
endif
ifeq ($(CONFIG_LIB_LIBNTFS3G_FORCE),y)
	@$(MAKE) -C libntfs-3g shared
endif
ifeq ($(CONFIG_LIB_LIBBT_FORCE),y)
	@$(MAKE) -C libbluetooth shared
endif
ifeq ($(CONFIG_LIB_READLINE_FORCE),y)
	@$(MAKE) -C libreadline shared
endif
ifeq ($(CONFIG_LIB_LIBSQLITE3_FORCE),y)
	@$(MAKE) -C libsqlite3 shared
endif
ifeq ($(CONFIG_LIB_LIBEXIF_FORCE),y)
	@$(MAKE) -C libexif shared
endif
ifeq ($(CONFIG_LIB_LIBOGG_FORCE),y)
	@$(MAKE) -C libogg shared
endif
ifeq ($(CONFIG_LIB_LIBVORBIS_FORCE),y)
	@$(MAKE) -C libvorbis shared
endif
ifeq ($(CONFIG_LIB_LIBFLAC_FORCE),y)
	@$(MAKE) -C libflac shared
endif
ifeq ($(CONFIG_LIB_LIBJPEG_FORCE),y)
	@$(MAKE) -C libjpeg shared
endif
ifeq ($(CONFIG_LIB_LIBPCAP_FORCE),y)
	@$(MAKE) -C libpcap-1.0.0 shared
endif
ifeq ($(CONFIG_LIB_LIBEVENT_FORCE),y)
	@$(MAKE) -C libevent-2.0.2-alpha shared
endif
ifeq ($(CONFIG_LIB_NCURSE_FORCE),y)
	@$(MAKE) -C libncurses-5.7 shared
endif
ifeq ($(CONFIG_LIB_FLEX_FORCE),y)
	@$(MAKE) -C libflex shared
endif
ifeq ($(CONFIG_LIB_LIBUPNP_FORCE),y)
	@$(MAKE) -C libupnp shared
endif
ifeq ($(CONFIG_LIB_LIBUPNP166_FORCE),y)
	@$(MAKE) -C libupnp-1.6.6
endif
ifeq ($(CONFIG_LIB_LIBUPNP166_DMS_FORCE),y)
	@$(MAKE) -C libupnp-1.6.6-dms
endif
ifeq ($(CONFIG_LIB_LIBFFMPEG_FORCE),y)
	@$(MAKE) -C libffmpeg-0.5
endif
ifeq ($(CONFIG_LIB_LIBDLNA_FORCE),y)
	@$(MAKE) -C libdlna-0.2.3
endif
ifeq ($(CONFIG_LIB_LIBGDBM_FORCE),y)
	@$(MAKE) -C libgdbm-1.8.3 shared
endif
ifeq ($(CONFIG_LIB_LIBID3TAG_FORCE),y)
	@$(MAKE) -C libid3tag-0.15.1b shared
endif
ifeq ($(CONFIG_LIB_LIBGMP_FORCE),y)
	@$(MAKE) -C libgmp shared
endif
ifeq ($(CONFIG_LIB_ZLIB_FORCE),y)
	@$(MAKE) -C zlib-1.2.3 shared
endif
ifeq ($(CONFIG_LIB_LIBZEBRA_FORCE),y)
	@$(MAKE) -C libzebra shared
endif
ifeq ($(CONFIG_LIB_USB0112_FORCE),y)
	@$(MAKE) -C libusb-0.1.12 shared
endif
ifeq ($(CONFIG_LIB_USB100_FORCE),y)
	@$(MAKE) -C libusb-1.0.0 shared
endif
ifeq ($(CONFIG_LIB_PCRE_FORCE),y)
	@$(MAKE) -C pcre-8.01 shared
endif
ifeq ($(CONFIG_LIB_VSTR_FORCE),y)
	@$(MAKE) -C vstr-1.0.15 shared
endif
else
	$(SECHO)
	$(SECHO) Not building shared libraries ...
	$(SECHO)
endif

finished: shared
	$(SECHO)
	$(SECHO) Finally finished compiling ...
	$(SECHO)

include/bits/uClibc_config.h: .config
	@if [ ! -x ./extra/config/conf ] ; then \
	    $(MAKE) -C extra/config conf; \
	fi;
	$(RM) -r include/bits
	$(INSTALL) -d include/bits
	@./extra/config/conf -o extra/Configs/Config.in

# For the moment, we have to keep re-running this target 
# because the fix includes scripts rely on pre-processers 
# in order to generate the headers correctly :(.  That 
# means we can't use the $(HOSTCC) in order to get the 
# correct output.
ifeq ($(strip $(ARCH_HAS_MMU)),y)
export header_extra_args = 
else
export header_extra_args = -n
endif
headers: include/bits/uClibc_config.h
	@$(SHELL_SET_X); \
	./extra/scripts/fix_includes.sh \
		-k $(KERNEL_SOURCE) -t $(TARGET_ARCH) \
		$(header_extra_args)
	@cd include/bits; \
	set -e; \
	for i in `ls ../../libc/sysdeps/linux/common/bits/*.h` ; do \
		$(LN) -fs $$i .; \
	done; \
	if [ -d ../../libc/sysdeps/linux/$(TARGET_ARCH)/bits ] ; then \
		for i in `ls ../../libc/sysdeps/linux/$(TARGET_ARCH)/bits/*.h` ; do \
			$(LN) -fs $$i .; \
		done; \
	fi
	@cd include/sys; \
	set -e; \
	for i in `ls ../../libc/sysdeps/linux/common/sys/*.h` ; do \
		$(LN) -fs $$i .; \
	done; \
	if [ -d ../../libc/sysdeps/linux/$(TARGET_ARCH)/sys ] ; then \
		for i in `ls ../../libc/sysdeps/linux/$(TARGET_ARCH)/sys/*.h` ; do \
			$(LN) -fs $$i .; \
		done; \
	fi
	@cd $(TOPDIR); \
	set -e; \
	$(SHELL_SET_X); \
	TOPDIR=. CC="$(CC)" /bin/sh extra/scripts/gen_bits_syscall_h.sh > include/bits/sysnum.h.new; \
	if cmp include/bits/sysnum.h include/bits/sysnum.h.new >/dev/null 2>&1; then \
		$(RM) include/bits/sysnum.h.new; \
	else \
		mv -f include/bits/sysnum.h.new include/bits/sysnum.h; \
	fi
	$(MAKE) -C libc/sysdeps/linux/common headers
	$(MAKE) -C libc/sysdeps/linux/$(TARGET_ARCH) headers

# Command used to download source code
WGET:=wget --passive-ftp

LOCALE_DATA_FILENAME:=uClibc-locale-030818.tgz

pregen: headers
ifeq ($(strip $(UCLIBC_DOWNLOAD_PREGENERATED_LOCALE_DATA)),y)
	(cd extra/locale; \
	if [ ! -f $(LOCALE_DATA_FILENAME) ] ; then \
	$(WGET) http://www.uclibc.org/downloads/$(LOCALE_DATA_FILENAME) ; \
	fi );
endif
ifeq ($(strip $(UCLIBC_PREGENERATED_LOCALE_DATA)),y)
	(cd extra/locale; zcat $(LOCALE_DATA_FILENAME) | tar -xvf -)
	$(MAKE) -C extra/locale pregen
endif


subdirs: $(patsubst %, _dir_%, $(DIRS))
$(patsubst %, _dir_%, $(DIRS)): headers
	$(MAKE) -C $(patsubst _dir_%, %, $@)

tags:
	ctags -R

install: install_runtime install_dev finished2

#added by Steven Liu
romfs: install_runtime
#--


RUNTIME_PREFIX_LIB_FROM_DEVEL_PREFIX_LIB=$(shell extra/scripts/relative_path.sh $(DEVEL_PREFIX)lib $(RUNTIME_PREFIX)lib)

# Installs header files and development library links.
install_dev:
	$(INSTALL) -d $(PREFIX)$(DEVEL_PREFIX)lib
	$(INSTALL) -d $(PREFIX)$(DEVEL_PREFIX)include
	-$(INSTALL) -m 644 lib/*.[ao] $(PREFIX)$(DEVEL_PREFIX)lib/
	if [ "$(KERNEL_SOURCE)" == "$(DEVEL_PREFIX)" ] ; then \
		extra_exclude="--exclude include/linux --exclude include/asm'*'" ; \
	else \
		extra_exclude="" ; \
	fi ; \
	tar -chf - include --exclude .svn --exclude CVS $$extra_exclude \
		| tar -xf - -C $(PREFIX)$(DEVEL_PREFIX)
ifneq ($(strip $(UCLIBC_HAS_FLOATS)),y)
	# Remove floating point related headers since float support is disabled.
	$(RM) $(PREFIX)$(DEVEL_PREFIX)include/complex.h
	$(RM) $(PREFIX)$(DEVEL_PREFIX)include/fpu_control.h
	$(RM) $(PREFIX)$(DEVEL_PREFIX)include/ieee754.h
	$(RM) $(PREFIX)$(DEVEL_PREFIX)include/math.h
	$(RM) $(PREFIX)$(DEVEL_PREFIX)include/tgmath.h
endif
ifneq ($(strip $(UCLIBC_HAS_WCHAR)),y)
	# Remove wide char headers since wide char support is disabled.
	$(RM) $(PREFIX)$(DEVEL_PREFIX)include/wctype.h
	$(RM) $(PREFIX)$(DEVEL_PREFIX)include/wchar.h
endif
ifneq ($(strip $(UCLIBC_HAS_LOCALE)),y)
	# Remove iconv header since locale support is disabled.
	$(RM) $(PREFIX)$(DEVEL_PREFIX)include/iconv.h
endif
ifneq ($(strip $(UCLIBC_HAS_GLIBC_CUSTOM_PRINTF)),y)
	# Remove printf header since custom print specifier support is disabled.
	$(RM) $(PREFIX)$(DEVEL_PREFIX)include/printf.h
endif
ifneq ($(strip $(UCLIBC_HAS_XLOCALE)),y)
	# Remove xlocale header since extended locale support is disabled.
	$(RM) $(PREFIX)$(DEVEL_PREFIX)include/xlocale.h
endif
ifneq ($(strip $(UCLIBC_HAS_GETTEXT_AWARENESS)),y)
	# Remove libintl header since gettext support is disabled.
	$(RM) $(PREFIX)$(DEVEL_PREFIX)include/libintl.h
endif
ifneq ($(strip $(UCLIBC_HAS_REGEX)),y)
	# Remove regex headers since regex support is disabled.
	$(RM) $(PREFIX)$(DEVEL_PREFIX)include/regex.h
	$(RM) $(PREFIX)$(DEVEL_PREFIX)include/regexp.h
endif
ifneq ($(strip $(UCLIBC_HAS_WORDEXP)),y)
	# Remove wordexp header since wordexp support is disabled.
	$(RM) $(PREFIX)$(DEVEL_PREFIX)include/wordexp.h
endif
ifneq ($(strip $(UCLIBC_HAS_FTW)),y)
	# Remove ftw header since ftw support is disabled.
	$(RM) $(PREFIX)$(DEVEL_PREFIX)include/ftw.h
endif
ifneq ($(strip $(UCLIBC_HAS_GLOB)),y)
	# Remove glob header since glob support is disabled.
	$(RM) $(PREFIX)$(DEVEL_PREFIX)include/glob.h
endif
ifneq ($(strip $(UCLIBC_HAS_GNU_GETOPT)),y)
