=== user/ecmh/debian/control ===
Source: ecmh
Section: net
Priority: optional
Maintainer: Jeroen Massar <jeroen@unfix.org>
Build-Depends: debhelper (>> 3.0.0)
Standards-Version: 3.5.2

Package: ecmh
Architecture: any
Depends: ${shlibs:Depends}
Recommends: radvd
Description: Multicast Routing Daemon
 Easy Cast du Multi Hub (ecmh) is a networking daemon that relays and
 aggregates multicast packets from/to network interfaces.
 .
 Currently it supports IPv6 Multicast using MLDv1 and MLDv2 including
 Source Specific Multicast (SSM).
 .
 It is used by SixXS (http://www.sixxs.net) to enable the users to
 send and receive Multicast IPv6 over IPv6 tunnels provided by SixXS.
 .
 Website: http://unfix.org/projects/ecmh/
